/* MACHINE-GENERATED - DO NOT EDIT ! */

#ifndef _LINUX_ABISS_MSG_BASIC_H
#define _LINUX_ABISS_MSG_BASIC_H

/*
 * include/linux/abiss_msg_basic.h - ABISS messages of the basic scheduler
 *
 * Written 2003-2005 by Werner Almesberger
 * 
 * (C) Copyright Koninklijke Philips Electronics NV 2003-2005. All rights
 * reserved.
 * 
 * You can redistribute and/or modify this software under the terms of
 * version 2 of the GNU General Public License as published by the Free
 * Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc., 59
 * Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#include <stdint.h>
#include <sys/types.h>
#include <linux/types.h>
#include <abiss_msg.h>


/* ----- abiss_attach ------------------------------------------------------ */



struct abiss_sched_basic_prm {
	size_t ra_bytes;	/* read-ahead bytes */
	size_t batch_bytes;	/* number of bytes to load before we start
				   reading */
	int fill_Bps;		/* fill rate in _bytes_ per second, 0 for BE */
	size_t consider_write;	/* if non-zero, try to see what happens if
				   extending the file by that many bytes
				   (development only - do not use) */
	unsigned long _rsv_0;	/* reserved for future use.		*/
	unsigned long _rsv_1;   /* MUST					*/
	unsigned long _rsv_2;   /* BE					*/
	unsigned long _rsv_3;   /* ZERO !				*/
};


#if defined(__KERNEL__) && defined(CONFIG_COMPAT)

/*
 * Near-clone of "struct abiss_sched_basic_prm", for 32 bit ioctl conversion.
 * Do not use this in applications !
 */

struct abiss_sched_basic_prm_compat {
	compat_size_t ra_bytes;
	compat_size_t batch_bytes;
	int fill_Bps;
	compat_size_t consider_write;
};

#endif /* __KERNEL__ && CONFIG_COMPAT */


struct abiss_alloc_test_prm {
	size_t min_contiguous;	/* allocate at least that many bytes at once */
};


#if defined(__KERNEL__) && defined(CONFIG_COMPAT)

/*
 * Near-clone of "struct abiss_sched_basic_prm", for 32 bit ioctl conversion.
 * Do not use this in applications !
 */

struct abiss_alloc_test_prm_compat {
	compat_size_t min_contiguous;
};

#endif /* __KERNEL__ && CONFIG_COMPAT */


/* ----- abiss_sched_msg --------------------------------------------------- */


enum abiss_sched_basic {
	abiss_sb_time_s,	/* simulate time moving (in seconds) */
	abiss_sb_time_ms,	/* idem, in milliseconds */
	abiss_sb_time_us,	/* idem, in microseconds */
	abiss_sb_time_jiffies,	/* idem, in jiffies */
	abiss_sb_query,		/* query playout buffer status */
};


struct abiss_sched_basic_msg {
	struct abiss_msg header;
	enum abiss_sched_basic type;
	union {
		struct {
			unsigned long new_time;	/* time in above unit */
			int relative;		/* 1 if relative to curr time */
		} time;
		struct abiss_sb_query {
			char  *page_state; /* or NULL */
				/*
				 * 'X'	   page not in file
				 * 'U'	   page is up to date and locked
				 * 'R'...  pending request
				 */
			int pages;		/* page_state length, in/out */
						/* ignored if !page_state  */
			int ra_pages;		/* playout pt. offset, out */
			loff_t playout;		/* kernel playout point */
			loff_t playout_goal;	/* user playout point */
			int credit;		/* current credit (bytes) */
			int max_credit;		/* maximum credit (bytes) */
		} query;
	} u;
};


#if defined(__KERNEL__) && defined(CONFIG_COMPAT)

/*
 * Near-clone of "struct abiss_sched_basic_msg", for 32 bit ioctl conversion.
 * Do not use this in applications !
 */

struct abiss_sched_basic_msg_compat {
	struct abiss_msg header;
	enum abiss_sched_basic type;
	union {
		struct {
			int relative;
			__u32 _pad;
			compat_time_t new_time;
		} time;
		struct {
			int pages;
			int ra_pages;
			loff_t playout;
			loff_t playout_goal;
			int credit;
			int max_credit;
			compat_uptr_t page_state;
		} query;
	} u;
};

#endif /* __KERNEL__ && CONFIG_COMPAT */

#endif /* _LINUX_ABISS_MSG_BASIC_H */
