/* MACHINE-GENERATED - DO NOT EDIT ! */

#ifndef _LINUX_ABISSD_MSG_H
#define _LINUX_ABISSD_MSG_H

/*
 * include/linux/abissd_msg.h - ABISS demon messages
 *
 * Written 2004, 2005 by Werner Almesberger
 * 
 * (C) Copyright Koninklijke Philips Electronics NV 2004, 2005. All rights
 * reserved.
 * 
 * You can redistribute and/or modify this software under the terms of
 * version 2 of the GNU General Public License as published by the Free
 * Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc., 59
 * Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


#include <stdint.h>
#include <sys/types.h>
#include <linux/types.h>
#include <abiss_msg.h> /* for ABISS_NAME_LENGTH */


enum abissd_msg {
	abissd_open_req,
	abissd_close_ind,
	abissd_disk_suspend_req,
	abissd_disk_resume_req,
	abissd_unsolicited,
};

struct abissd_id {
	uint64_t	dev;	/* device number */
	uint64_t	ino;	/* inode number */
	uint64_t	fid;	/* open file ID (filp pointer) */
};

struct abissd_extent {
	uint64_t	start;	/* first byte of extent (into device) */
	uint64_t	length;/* length of extent (in bytes) */
};

struct abissd_open_msg {
	enum abissd_msg type;	/* abissd_open_req; MUST BE FIRST */
	int	pid;		/* requestor's PID */
	struct abissd_id id;
	char	sched_name[ABISS_NAME_LENGTH];
	uint64_t	file_size;	/* file size (bytes) */
	int	sched_prm_len;	/* scheduler parameters follow this structure */
	int	num_extents;	/* number of extents following the scheduler
				   parameters */
	int	error;		/* reply only; 0 on success */
	int	mode;		/* file mode, O_RDONLY, O_RDWR, or O_WRONLY */
	/* @@@ add allocator later */
};

struct abissd_close_msg {
	enum abissd_msg type;	/* abissd_close_ind; MUST BE FIRST */
	int _dummy;		/* 64 bit-compatible alignment */
	struct abissd_id id;
};

struct abissd_disk_msg {
	enum abissd_msg type;	/* MUST BE FIRST */
	int _dummy;		/* 64 bit-compatible alignment */
	struct abissd_id id;
};

struct abissd_unsolicited_msg {
	enum abissd_msg type;	/* abissd_unsolicited; MUST BE FIRST */
	int _dummy;		/* 64 bit-compatible alignment */
	struct abissd_id id;
};

#endif /* _LINUX_ABISSD_MSG_H */
